/**
 */
package tools.descartes.dni.dnimm3.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import tools.descartes.dni.dnimm3.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see tools.descartes.dni.dnimm3.DNIPackage
 * @generated
 */
public class DNISwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static DNIPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DNISwitch() {
		if (modelPackage == null) {
			modelPackage = DNIPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case DNIPackage.NAMED_ELEMENT: {
				NamedElement namedElement = (NamedElement)theEObject;
				T result = caseNamedElement(namedElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.IDENTIFIER: {
				Identifier identifier = (Identifier)theEObject;
				T result = caseIdentifier(identifier);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.ENTITY: {
				Entity entity = (Entity)theEObject;
				T result = caseEntity(entity);
				if (result == null) result = caseIdentifier(entity);
				if (result == null) result = caseNamedElement(entity);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NETWORK_INFRASTRUCTURE: {
				NetworkInfrastructure networkInfrastructure = (NetworkInfrastructure)theEObject;
				T result = caseNetworkInfrastructure(networkInfrastructure);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NETWORK_STRUCTURE: {
				NetworkStructure networkStructure = (NetworkStructure)theEObject;
				T result = caseNetworkStructure(networkStructure);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NODE: {
				Node node = (Node)theEObject;
				T result = caseNode(node);
				if (result == null) result = caseEntity(node);
				if (result == null) result = caseIdentifier(node);
				if (result == null) result = caseNamedElement(node);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.END: {
				End end = (End)theEObject;
				T result = caseEnd(end);
				if (result == null) result = caseIdentifier(end);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.INTERMEDIATE: {
				Intermediate intermediate = (Intermediate)theEObject;
				T result = caseIntermediate(intermediate);
				if (result == null) result = caseIdentifier(intermediate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.LINK: {
				Link link = (Link)theEObject;
				T result = caseLink(link);
				if (result == null) result = caseEntity(link);
				if (result == null) result = caseIdentifier(link);
				if (result == null) result = caseNamedElement(link);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NETWORK_INTERFACE: {
				NetworkInterface networkInterface = (NetworkInterface)theEObject;
				T result = caseNetworkInterface(networkInterface);
				if (result == null) result = caseAddressableEntity(networkInterface);
				if (result == null) result = caseEntity(networkInterface);
				if (result == null) result = caseNamedElement(networkInterface);
				if (result == null) result = caseIdentifier(networkInterface);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NETWORK_TRAFFIC: {
				NetworkTraffic networkTraffic = (NetworkTraffic)theEObject;
				T result = caseNetworkTraffic(networkTraffic);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.FLOW: {
				Flow flow = (Flow)theEObject;
				T result = caseFlow(flow);
				if (result == null) result = caseEntity(flow);
				if (result == null) result = caseIdentifier(flow);
				if (result == null) result = caseNamedElement(flow);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.SDN_CONTROL_FLOW: {
				SdnControlFlow sdnControlFlow = (SdnControlFlow)theEObject;
				T result = caseSdnControlFlow(sdnControlFlow);
				if (result == null) result = caseFlow(sdnControlFlow);
				if (result == null) result = caseEntity(sdnControlFlow);
				if (result == null) result = caseIdentifier(sdnControlFlow);
				if (result == null) result = caseNamedElement(sdnControlFlow);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.FLOW_TRAFFIC: {
				FlowTraffic flowTraffic = (FlowTraffic)theEObject;
				T result = caseFlowTraffic(flowTraffic);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.GENERIC_FLOW_TRAFFIC: {
				GenericFlowTraffic genericFlowTraffic = (GenericFlowTraffic)theEObject;
				T result = caseGenericFlowTraffic(genericFlowTraffic);
				if (result == null) result = caseFlowTraffic(genericFlowTraffic);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.COMMUNICATING_APPLICATION: {
				CommunicatingApplication communicatingApplication = (CommunicatingApplication)theEObject;
				T result = caseCommunicatingApplication(communicatingApplication);
				if (result == null) result = caseEntity(communicatingApplication);
				if (result == null) result = caseIdentifier(communicatingApplication);
				if (result == null) result = caseNamedElement(communicatingApplication);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.TRAFFIC_SOURCE: {
				TrafficSource trafficSource = (TrafficSource)theEObject;
				T result = caseTrafficSource(trafficSource);
				if (result == null) result = caseEntity(trafficSource);
				if (result == null) result = caseAddressableEntity(trafficSource);
				if (result == null) result = caseIdentifier(trafficSource);
				if (result == null) result = caseNamedElement(trafficSource);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NETWORK_CONFIGURATION: {
				NetworkConfiguration networkConfiguration = (NetworkConfiguration)theEObject;
				T result = caseNetworkConfiguration(networkConfiguration);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.PROTOCOLS_REPOSITORY: {
				ProtocolsRepository protocolsRepository = (ProtocolsRepository)theEObject;
				T result = caseProtocolsRepository(protocolsRepository);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.PROTOCOL_STACK: {
				ProtocolStack protocolStack = (ProtocolStack)theEObject;
				T result = caseProtocolStack(protocolStack);
				if (result == null) result = caseEntity(protocolStack);
				if (result == null) result = caseIdentifier(protocolStack);
				if (result == null) result = caseNamedElement(protocolStack);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.PROTOCOL_LAYER: {
				ProtocolLayer protocolLayer = (ProtocolLayer)theEObject;
				T result = caseProtocolLayer(protocolLayer);
				if (result == null) result = caseEntity(protocolLayer);
				if (result == null) result = caseIdentifier(protocolLayer);
				if (result == null) result = caseNamedElement(protocolLayer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NETWORK_PROTOCOL: {
				NetworkProtocol networkProtocol = (NetworkProtocol)theEObject;
				T result = caseNetworkProtocol(networkProtocol);
				if (result == null) result = caseEntity(networkProtocol);
				if (result == null) result = caseIdentifier(networkProtocol);
				if (result == null) result = caseNamedElement(networkProtocol);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.ROUTES_REPOSITORY: {
				RoutesRepository routesRepository = (RoutesRepository)theEObject;
				T result = caseRoutesRepository(routesRepository);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.DIRECTION: {
				Direction direction = (Direction)theEObject;
				T result = caseDirection(direction);
				if (result == null) result = caseEntity(direction);
				if (result == null) result = caseIdentifier(direction);
				if (result == null) result = caseNamedElement(direction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.FLOW_ROUTE: {
				FlowRoute flowRoute = (FlowRoute)theEObject;
				T result = caseFlowRoute(flowRoute);
				if (result == null) result = caseEntity(flowRoute);
				if (result == null) result = caseIdentifier(flowRoute);
				if (result == null) result = caseNamedElement(flowRoute);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.ROUTE: {
				Route route = (Route)theEObject;
				T result = caseRoute(route);
				if (result == null) result = caseEntity(route);
				if (result == null) result = caseIdentifier(route);
				if (result == null) result = caseNamedElement(route);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.HOP: {
				Hop hop = (Hop)theEObject;
				T result = caseHop(hop);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.ENTITY_ADDRESS: {
				EntityAddress entityAddress = (EntityAddress)theEObject;
				T result = caseEntityAddress(entityAddress);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.ADDRESSABLE_ENTITY: {
				AddressableEntity addressableEntity = (AddressableEntity)theEObject;
				T result = caseAddressableEntity(addressableEntity);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.WORKLOAD: {
				Workload workload = (Workload)theEObject;
				T result = caseWorkload(workload);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.GENERIC_WORKLOAD: {
				GenericWorkload genericWorkload = (GenericWorkload)theEObject;
				T result = caseGenericWorkload(genericWorkload);
				if (result == null) result = caseWorkload(genericWorkload);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.ABSTRACT_ACTION: {
				AbstractAction abstractAction = (AbstractAction)theEObject;
				T result = caseAbstractAction(abstractAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.BRANCH_ACTION: {
				BranchAction branchAction = (BranchAction)theEObject;
				T result = caseBranchAction(branchAction);
				if (result == null) result = caseAbstractAction(branchAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.LOOP_ACTION: {
				LoopAction loopAction = (LoopAction)theEObject;
				T result = caseLoopAction(loopAction);
				if (result == null) result = caseAbstractAction(loopAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.SEQUENCE_ACTION: {
				SequenceAction sequenceAction = (SequenceAction)theEObject;
				T result = caseSequenceAction(sequenceAction);
				if (result == null) result = caseAbstractAction(sequenceAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.START_ACTION: {
				StartAction startAction = (StartAction)theEObject;
				T result = caseStartAction(startAction);
				if (result == null) result = caseAbstractAction(startAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.STOP_ACTION: {
				StopAction stopAction = (StopAction)theEObject;
				T result = caseStopAction(stopAction);
				if (result == null) result = caseAbstractAction(stopAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.TRANSMIT_ACTION: {
				TransmitAction transmitAction = (TransmitAction)theEObject;
				T result = caseTransmitAction(transmitAction);
				if (result == null) result = caseAbstractAction(transmitAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.WAIT_ACTION: {
				WaitAction waitAction = (WaitAction)theEObject;
				T result = caseWaitAction(waitAction);
				if (result == null) result = caseAbstractAction(waitAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.PERFORMANCE_SPECIFICATION: {
				PerformanceSpecification performanceSpecification = (PerformanceSpecification)theEObject;
				T result = casePerformanceSpecification(performanceSpecification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.PERFORMANCE_LINK: {
				PerformanceLink performanceLink = (PerformanceLink)theEObject;
				T result = casePerformanceLink(performanceLink);
				if (result == null) result = casePerformanceSpecification(performanceLink);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.PERFORMANCE_NETWORK_INTERFACE: {
				PerformanceNetworkInterface performanceNetworkInterface = (PerformanceNetworkInterface)theEObject;
				T result = casePerformanceNetworkInterface(performanceNetworkInterface);
				if (result == null) result = casePerformanceSpecification(performanceNetworkInterface);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.SDN_FLOW_RULE: {
				SdnFlowRule sdnFlowRule = (SdnFlowRule)theEObject;
				T result = caseSdnFlowRule(sdnFlowRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.SDN_CONTROLLER: {
				SdnController sdnController = (SdnController)theEObject;
				T result = caseSdnController(sdnController);
				if (result == null) result = caseCommunicatingApplication(sdnController);
				if (result == null) result = caseEntity(sdnController);
				if (result == null) result = caseIdentifier(sdnController);
				if (result == null) result = caseNamedElement(sdnController);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.SDN_CONTROLLER_APPLICATION: {
				SdnControllerApplication sdnControllerApplication = (SdnControllerApplication)theEObject;
				T result = caseSdnControllerApplication(sdnControllerApplication);
				if (result == null) result = caseCommunicatingApplication(sdnControllerApplication);
				if (result == null) result = caseEntity(sdnControllerApplication);
				if (result == null) result = caseIdentifier(sdnControllerApplication);
				if (result == null) result = caseNamedElement(sdnControllerApplication);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.ITYPE: {
				IType iType = (IType)theEObject;
				T result = caseIType(iType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.COMMON: {
				Common common = (Common)theEObject;
				T result = caseCommon(common);
				if (result == null) result = caseIType(common);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.SDN: {
				SDN sdn = (SDN)theEObject;
				T result = caseSDN(sdn);
				if (result == null) result = caseIType(sdn);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.INTERMEDIATE_PERFORMANCE: {
				IntermediatePerformance intermediatePerformance = (IntermediatePerformance)theEObject;
				T result = caseIntermediatePerformance(intermediatePerformance);
				if (result == null) result = casePerformanceSpecification(intermediatePerformance);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.END_PERFORMANCE: {
				EndPerformance endPerformance = (EndPerformance)theEObject;
				T result = caseEndPerformance(endPerformance);
				if (result == null) result = casePerformanceSpecification(endPerformance);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.PERFORMANCE_SDN_NODE: {
				PerformanceSdnNode performanceSdnNode = (PerformanceSdnNode)theEObject;
				T result = casePerformanceSdnNode(performanceSdnNode);
				if (result == null) result = casePerformanceSpecification(performanceSdnNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.DNI_UNIT: {
				DNIUnit dniUnit = (DNIUnit)theEObject;
				T result = caseDNIUnit(dniUnit);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.SPEED_UNIT: {
				SpeedUnit speedUnit = (SpeedUnit)theEObject;
				T result = caseSpeedUnit(speedUnit);
				if (result == null) result = caseDNIUnit(speedUnit);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.DATA_UNIT: {
				DataUnit dataUnit = (DataUnit)theEObject;
				T result = caseDataUnit(dataUnit);
				if (result == null) result = caseDNIUnit(dataUnit);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.TIME_UNIT: {
				TimeUnit timeUnit = (TimeUnit)theEObject;
				T result = caseTimeUnit(timeUnit);
				if (result == null) result = caseDNIUnit(timeUnit);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.DEPENDENCY: {
				Dependency dependency = (Dependency)theEObject;
				T result = caseDependency(dependency);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.VARIABLE: {
				Variable variable = (Variable)theEObject;
				T result = caseVariable(variable);
				if (result == null) result = caseDependency(variable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.FUNCTION: {
				Function function = (Function)theEObject;
				T result = caseFunction(function);
				if (result == null) result = caseDependency(function);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.CONSTANT_DOUBLE_VARIABLE: {
				ConstantDoubleVariable constantDoubleVariable = (ConstantDoubleVariable)theEObject;
				T result = caseConstantDoubleVariable(constantDoubleVariable);
				if (result == null) result = caseVariable(constantDoubleVariable);
				if (result == null) result = caseDependency(constantDoubleVariable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.CONSTANT_LONG_VARIABLE: {
				ConstantLongVariable constantLongVariable = (ConstantLongVariable)theEObject;
				T result = caseConstantLongVariable(constantLongVariable);
				if (result == null) result = caseVariable(constantLongVariable);
				if (result == null) result = caseDependency(constantLongVariable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.RANDOM_VARIABLE: {
				RandomVariable randomVariable = (RandomVariable)theEObject;
				T result = caseRandomVariable(randomVariable);
				if (result == null) result = caseVariable(randomVariable);
				if (result == null) result = caseDependency(randomVariable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.FLOAT_COORDINATE: {
				FloatCoordinate floatCoordinate = (FloatCoordinate)theEObject;
				T result = caseFloatCoordinate(floatCoordinate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.DISCRETE_FUNCTION: {
				DiscreteFunction discreteFunction = (DiscreteFunction)theEObject;
				T result = caseDiscreteFunction(discreteFunction);
				if (result == null) result = caseFunction(discreteFunction);
				if (result == null) result = caseDependency(discreteFunction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.EXPONENTIAL_FUNCTION: {
				ExponentialFunction exponentialFunction = (ExponentialFunction)theEObject;
				T result = caseExponentialFunction(exponentialFunction);
				if (result == null) result = caseFunction(exponentialFunction);
				if (result == null) result = caseDependency(exponentialFunction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.ENTITY_TYPES: {
				EntityTypes entityTypes = (EntityTypes)theEObject;
				T result = caseEntityTypes(entityTypes);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.ITYPED_ENTITY: {
				ITypedEntity iTypedEntity = (ITypedEntity)theEObject;
				T result = caseITypedEntity(iTypedEntity);
				if (result == null) result = caseNamedElement(iTypedEntity);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NODE_TYPE: {
				NodeType nodeType = (NodeType)theEObject;
				T result = caseNodeType(nodeType);
				if (result == null) result = caseITypedEntity(nodeType);
				if (result == null) result = caseNamedElement(nodeType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.END_PERFORMANCE_TYPE: {
				EndPerformanceType endPerformanceType = (EndPerformanceType)theEObject;
				T result = caseEndPerformanceType(endPerformanceType);
				if (result == null) result = caseITypedEntity(endPerformanceType);
				if (result == null) result = caseNamedElement(endPerformanceType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.INTERMEDIATE_PERFORMANCE_TYPE: {
				IntermediatePerformanceType intermediatePerformanceType = (IntermediatePerformanceType)theEObject;
				T result = caseIntermediatePerformanceType(intermediatePerformanceType);
				if (result == null) result = caseITypedEntity(intermediatePerformanceType);
				if (result == null) result = caseNamedElement(intermediatePerformanceType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.SDN_NODE_PERFORMANCE_TYPE: {
				SdnNodePerformanceType sdnNodePerformanceType = (SdnNodePerformanceType)theEObject;
				T result = caseSdnNodePerformanceType(sdnNodePerformanceType);
				if (result == null) result = caseITypedEntity(sdnNodePerformanceType);
				if (result == null) result = caseNamedElement(sdnNodePerformanceType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NETWORK_INTERFACE_TYPE: {
				NetworkInterfaceType networkInterfaceType = (NetworkInterfaceType)theEObject;
				T result = caseNetworkInterfaceType(networkInterfaceType);
				if (result == null) result = caseITypedEntity(networkInterfaceType);
				if (result == null) result = caseNamedElement(networkInterfaceType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.NETWORK_INTERFACE_PERFORMANCE_TYPE: {
				NetworkInterfacePerformanceType networkInterfacePerformanceType = (NetworkInterfacePerformanceType)theEObject;
				T result = caseNetworkInterfacePerformanceType(networkInterfacePerformanceType);
				if (result == null) result = caseITypedEntity(networkInterfacePerformanceType);
				if (result == null) result = caseNamedElement(networkInterfacePerformanceType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.LINK_TYPE: {
				LinkType linkType = (LinkType)theEObject;
				T result = caseLinkType(linkType);
				if (result == null) result = caseITypedEntity(linkType);
				if (result == null) result = caseNamedElement(linkType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case DNIPackage.LINK_PERFORMANCE_TYPE: {
				LinkPerformanceType linkPerformanceType = (LinkPerformanceType)theEObject;
				T result = caseLinkPerformanceType(linkPerformanceType);
				if (result == null) result = caseITypedEntity(linkPerformanceType);
				if (result == null) result = caseNamedElement(linkPerformanceType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Named Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNamedElement(NamedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Identifier</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Identifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIdentifier(Identifier object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Entity</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Entity</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEntity(Entity object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Network Infrastructure</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Network Infrastructure</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetworkInfrastructure(NetworkInfrastructure object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Network Structure</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Network Structure</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetworkStructure(NetworkStructure object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNode(Node object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>End</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>End</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEnd(End object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Intermediate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Intermediate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIntermediate(Intermediate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Link</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLink(Link object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Network Interface</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Network Interface</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetworkInterface(NetworkInterface object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Network Traffic</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Network Traffic</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetworkTraffic(NetworkTraffic object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Flow</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Flow</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFlow(Flow object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sdn Control Flow</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sdn Control Flow</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSdnControlFlow(SdnControlFlow object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Flow Traffic</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Flow Traffic</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFlowTraffic(FlowTraffic object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Generic Flow Traffic</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Generic Flow Traffic</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGenericFlowTraffic(GenericFlowTraffic object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Communicating Application</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Communicating Application</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCommunicatingApplication(CommunicatingApplication object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Traffic Source</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Traffic Source</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTrafficSource(TrafficSource object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Network Configuration</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Network Configuration</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetworkConfiguration(NetworkConfiguration object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Protocols Repository</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Protocols Repository</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseProtocolsRepository(ProtocolsRepository object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Protocol Stack</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Protocol Stack</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseProtocolStack(ProtocolStack object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Protocol Layer</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Protocol Layer</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseProtocolLayer(ProtocolLayer object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Network Protocol</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Network Protocol</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetworkProtocol(NetworkProtocol object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Routes Repository</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Routes Repository</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRoutesRepository(RoutesRepository object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Direction</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Direction</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDirection(Direction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Flow Route</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Flow Route</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFlowRoute(FlowRoute object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Route</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Route</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRoute(Route object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Hop</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Hop</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHop(Hop object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Entity Address</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Entity Address</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEntityAddress(EntityAddress object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Addressable Entity</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Addressable Entity</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAddressableEntity(AddressableEntity object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Workload</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Workload</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseWorkload(Workload object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Generic Workload</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Generic Workload</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGenericWorkload(GenericWorkload object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Abstract Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Abstract Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAbstractAction(AbstractAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Branch Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Branch Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBranchAction(BranchAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Loop Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Loop Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLoopAction(LoopAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sequence Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sequence Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSequenceAction(SequenceAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Start Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Start Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStartAction(StartAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Stop Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Stop Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStopAction(StopAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Transmit Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Transmit Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTransmitAction(TransmitAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Wait Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Wait Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseWaitAction(WaitAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Performance Specification</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Performance Specification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePerformanceSpecification(PerformanceSpecification object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Performance Link</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Performance Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePerformanceLink(PerformanceLink object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Performance Network Interface</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Performance Network Interface</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePerformanceNetworkInterface(PerformanceNetworkInterface object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sdn Flow Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sdn Flow Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSdnFlowRule(SdnFlowRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sdn Controller</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sdn Controller</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSdnController(SdnController object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sdn Controller Application</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sdn Controller Application</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSdnControllerApplication(SdnControllerApplication object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>IType</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IType</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIType(IType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Common</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Common</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCommon(Common object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SDN</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SDN</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSDN(SDN object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Intermediate Performance</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Intermediate Performance</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIntermediatePerformance(IntermediatePerformance object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>End Performance</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>End Performance</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEndPerformance(EndPerformance object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Performance Sdn Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Performance Sdn Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePerformanceSdnNode(PerformanceSdnNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Unit</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Unit</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDNIUnit(DNIUnit object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Speed Unit</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Speed Unit</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSpeedUnit(SpeedUnit object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Data Unit</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Data Unit</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDataUnit(DataUnit object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Time Unit</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Time Unit</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTimeUnit(TimeUnit object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Dependency</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Dependency</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDependency(Dependency object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Variable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Variable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVariable(Variable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Function</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Function</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFunction(Function object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Constant Double Variable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Constant Double Variable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseConstantDoubleVariable(ConstantDoubleVariable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Constant Long Variable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Constant Long Variable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseConstantLongVariable(ConstantLongVariable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Random Variable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Random Variable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRandomVariable(RandomVariable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Float Coordinate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Float Coordinate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFloatCoordinate(FloatCoordinate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Discrete Function</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Discrete Function</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDiscreteFunction(DiscreteFunction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Exponential Function</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Exponential Function</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseExponentialFunction(ExponentialFunction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Entity Types</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Entity Types</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEntityTypes(EntityTypes object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ITyped Entity</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ITyped Entity</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseITypedEntity(ITypedEntity object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Node Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Node Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNodeType(NodeType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>End Performance Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>End Performance Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEndPerformanceType(EndPerformanceType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Intermediate Performance Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Intermediate Performance Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIntermediatePerformanceType(IntermediatePerformanceType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sdn Node Performance Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sdn Node Performance Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSdnNodePerformanceType(SdnNodePerformanceType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Network Interface Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Network Interface Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetworkInterfaceType(NetworkInterfaceType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Network Interface Performance Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Network Interface Performance Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetworkInterfacePerformanceType(NetworkInterfacePerformanceType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Link Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Link Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLinkType(LinkType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Link Performance Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Link Performance Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLinkPerformanceType(LinkPerformanceType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //DNISwitch
